import fsmMgr

import math

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import screenInfo
import mouseInfo
import statePower

class StateAim(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)
        self.angle=0 #east, I guess

        #self.curPlan={"radius":40,
        #              "center":(80,80)}

        self.clicked=False

    def init(self):
        if self.parent:
            for obj in self.parent.physicsObjects:
                if obj.get("target",False):
                    cx,cy=obj["center"]

                    wx,wy=screenInfo.screenToWorldPos(cx,cy)
                    pygame.mouse.set_pos(wx,wy)

                    
                    break
            
        
    def update(self, dt):
        self.parent.update(dt)
        # read the mouse - set the angle to the mouse
        mouseInfo.readMouse()
        mx=mouseInfo.gMouseX
        my=mouseInfo.gMouseY
        px,py=self.parent.currentPlanet["center"]
        dx=mx-px
        dy=my-py
        
        self.angle=math.atan2(dy,dx)

    def handleMouseButton(self, bDown, buttonIndex):
        #calibrate power next

        if bDown==True and buttonIndex==1:
            self.clicked=True
        if bDown==False and buttonIndex==1 and self.clicked:
            self.parent.angle=self.angle
            fsmMgr.popState()
            fsmMgr.pushState(statePower.StatePower(self.parent))
            return True
        return False


    def draw(self):
        # first, let our parent draw the map
        self.parent.draw()
        
        # draw an arrow out of the planet in the direction of the
        # angle.
        # make sure to start it the radius of the current planet, and
        # go out from there.

        curPlan=self.parent.currentPlanet
        
        curPlanRad=curPlan["radius"]
        curPlanX,curPlanY=curPlan["center"]
        
        arrowLength=70
        headLength=20
        headAngle=0.20

        glBegin(GL_LINES)

        cursor_radius=20
        glColor3f(0, 0.7, 1)
        glVertex2f(mouseInfo.gMouseX-cursor_radius,
                   mouseInfo.gMouseY)
        glVertex2f(mouseInfo.gMouseX+cursor_radius,
                   mouseInfo.gMouseY)
        glVertex2f(mouseInfo.gMouseX,
                   mouseInfo.gMouseY-cursor_radius)
        glVertex2f(mouseInfo.gMouseX,
                   mouseInfo.gMouseY+cursor_radius)
                   

        glColor3f(0,1,0)
        arrowBaseX=curPlanX+math.cos(self.angle)*curPlanRad
        arrowBaseY=curPlanY+math.sin(self.angle)*curPlanRad

        arrowTipX=curPlanX+math.cos(self.angle)*(curPlanRad+arrowLength)
        arrowTipY=curPlanY+math.sin(self.angle)*(curPlanRad+arrowLength)

        glVertex2f(arrowBaseX,arrowBaseY)
        glVertex2f(arrowTipX,arrowTipY)

        arrowBarbX=curPlanX+math.cos(self.angle+headAngle)*(curPlanRad+arrowLength-headLength)
        arrowBarbY=curPlanY+math.sin(self.angle+headAngle)*(curPlanRad+arrowLength-headLength)
        glVertex2f(arrowTipX,arrowTipY)
        glVertex2f(arrowBarbX,arrowBarbY)

        arrowBarbX=curPlanX+math.cos(self.angle-headAngle)*(curPlanRad+arrowLength-headLength)
        arrowBarbY=curPlanY+math.sin(self.angle-headAngle)*(curPlanRad+arrowLength-headLength)
        glVertex2f(arrowTipX,arrowTipY)
        glVertex2f(arrowBarbX,arrowBarbY)
        glEnd()
