import fsmMgr

import math

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import screenInfo
import mouseInfo
import stateAim
import statePutt

class StatePower(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)
        self.power=0

        pygame.mouse.set_pos((screenInfo.gWindowX/2,
                              screenInfo.gWindowY/2))
        
        

    def update(self, dt):
        self.parent.update(dt)
        mouseInfo.readMouse()
        mx=mouseInfo.gMouseX
        my=mouseInfo.gMouseY
        
        self.power=my/600.0

    def handleMouseButton(self, bDown, buttonIndex):
        # next up, putt. Also, can back up to re-aim
        if bDown==False:
            if buttonIndex==1:
                # next
                fsmMgr.popState()
                fsmMgr.pushState(statePutt.StatePutt(None))
                self.parent.power=self.power
                return True
            if buttonIndex==3:
                # TODO: check this on Mac, Linux
                fsmMgr.popState()
                fsmMgr.pushState(stateAim.StateAim(None))
                return True
        return False


    def draw(self):
        # first, let our parent draw the map
        self.parent.draw()

        # want do do something entirely different here
        
        # draw an arrow out of the planet in the direction of the
        # angle.
        # make sure to start it the radius of the current planet, and
        # go out from there.

        curPlan=self.parent.currentPlanet
        
        curPlanRad=curPlan["radius"]
        curPlanX,curPlanY=curPlan["center"]
        
        arrowLength=100*self.power
        headLength=20*self.power
        headAngle=0.20*self.power

        drawPowerMeter(self.power)
        glBegin(GL_LINES)

        glColor3f(0,0,1)
        arrowBaseX=curPlanX+math.cos(self.parent.angle)*curPlanRad
        arrowBaseY=curPlanY+math.sin(self.parent.angle)*curPlanRad

        arrowTipX=curPlanX+math.cos(self.parent.angle)*(curPlanRad+arrowLength)
        arrowTipY=curPlanY+math.sin(self.parent.angle)*(curPlanRad+arrowLength)

        glVertex2f(arrowBaseX,arrowBaseY)
        glVertex2f(arrowTipX,arrowTipY)

        arrowBarbX=curPlanX+math.cos(self.parent.angle+headAngle)*(curPlanRad+arrowLength-headLength)
        arrowBarbY=curPlanY+math.sin(self.parent.angle+headAngle)*(curPlanRad+arrowLength-headLength)
        glVertex2f(arrowTipX,arrowTipY)
        glVertex2f(arrowBarbX,arrowBarbY)

        arrowBarbX=curPlanX+math.cos(self.parent.angle-headAngle)*(curPlanRad+arrowLength-headLength)
        arrowBarbY=curPlanY+math.sin(self.parent.angle-headAngle)*(curPlanRad+arrowLength-headLength)
        glVertex2f(arrowTipX,arrowTipY)
        glVertex2f(arrowBarbX,arrowBarbY)
        glEnd()


def drawPowerMeter(power):
    glBegin(GL_LINES)
    glColor3f(0.7, 0.7, 0.7)
    powerMeterX=760
    glVertex2f(powerMeterX,0)
    glVertex2f(powerMeterX,600)
        
    glColor3f(0.9, 0.5, 0.5)
    glVertex2f(powerMeterX-8,0)
    glVertex2f(powerMeterX-8,600*power)
    
    glVertex2f(powerMeterX+8,0)
    glVertex2f(powerMeterX+8,600*power)

    glVertex2f(powerMeterX-8,600*power)
    glVertex2f(powerMeterX+8,600*power)
    glEnd()
